
(*
 * quelib.inc - Circular Queue library
 *
 * (C) 1987 Samuel H. Smith, 30-May-87 (rev. 13-Dec-87)
 *
 *)


(*
 * INIT_QUE(queue)
 *
 *)

procedure init_que( var q: queue_rec);
begin
   q.next_in := 1;
   q.next_out := 1;
   q.count := 0;
end;


(*
 * EMPTY_QUE(queue): boolean
 *
 *)

function empty_que( var q: queue_rec ): boolean;
begin
   empty_que := q.count = 0;
end;


(*
 * QUE_FREE(queue): integer
 *
 *)

function que_free (var q: queue_rec): integer;
begin
   que_free := queue_size - q.count;
end;


(*
 * ENQUE(queue, char)
 *
 *)

procedure enque (var q: queue_rec; c: char);
begin
   inc(q.count);
   q.data[q.next_in] := c;
   if q.next_in < queue_size then
      inc(q.next_in)
   else
      q.next_in := 1;
end;


(*
 * DEQUE(queue,dest)
 *    (EMPTY_QUE check is required before calling DEQUE)
 *
 *)

procedure deque (var q: queue_rec; var c: char);
begin
   c := q.data[q.next_out];
   if q.next_out < queue_size then
      inc(q.next_out)
   else
      q.next_out := 1;
   dec(q.count);
end;

